;nyquist plug-in
;version 1
;type process
;categories "http://lv2plug.in/ns/lv2core#DelayPlugin"
;name "Multitap Delay..."
;action "Making Echoes..."
;info "by Steve Daulton. (www.easyspacepro.com).\nReleased under GPL v2.\n"

;; multitap.ny by Steve Daulton July 2012.
;; Released under terms of the GNU General Public License version 2:
;; http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
;;
;; For information about writing and modifying Nyquist plug-ins:
;; http://wiki.audacityteam.org/wiki/Nyquist_Plug-ins_Reference

;control delay1 "Delay 1 (ms)" real "" 50 0 1000
;control gain1 "Level" real "" 0.5 0 1
;control delay2 "Delay 2 (ms)" real "" 0 0 1000
;control gain2 "Level" real "" 0 0 1
;control delay3 "Delay 3 (ms)" real "" 0 0 1000
;control gain3 "Level" real "" 0 0 1
;control delay4 "Delay 4 (ms)" real "" 0 0 1000
;control gain4 "Level" real "" 0 0 1
;control delay5 "Delay 5 (ms)" real "" 0 0 1000
;control gain5 "Level" real "" 0 0 1
;control fback "Feedback (%)" int "" 20 0 95


(defmacro dl-sanitise (name)
`(setf ,name (max (min (* ,name 0.001) 1) 0)))

(defmacro db-sanitise (name)
`(setf ,name (max (min ,name 1) 0)))

(db-sanitise gain1)
(dl-sanitise delay1)
(db-sanitise gain2)
(dl-sanitise delay2)
(db-sanitise gain3)
(dl-sanitise delay3)
(db-sanitise gain4)
(dl-sanitise delay4)
(db-sanitise gain5)
(dl-sanitise delay5)
(setq fback (max (min (* 0.01 fback) 0.99) 0))

(sim
  s
  (if (and (> delay1 0)(> gain1 0))
    (scale gain1 (feedback-delay s delay1 fback)) 0)
  (if (and (> delay2 0)(> gain2 0))
    (scale gain2 (feedback-delay s delay2 fback)) 0)
  (if (and (> delay3 0)(> gain3 0))
    (scale gain3 (feedback-delay s delay3 fback)) 0)
  (if (and (> delay4 0)(> gain4 0))
    (scale gain4 (feedback-delay s delay4 fback)) 0)
  (if (and (> delay5 0)(> gain5 0))
    (scale gain5 (feedback-delay s delay5 fback)) 0))

